Index: fmtext.c
===================================================================
--- fmtext.c	(revision c55ad845105974d495240c5d81e7d0c536780951)
+++ fmtext.c	(revision fa3290d0243ae8fb36df1f09bbe9bc943d1efc06)
@@ -8,11 +8,14 @@
 void owl_fmtext_init_null(owl_fmtext *f)
 {
-  f->textlen = 0;
-  f->bufflen = 5;
-  f->textbuff = owl_malloc(5);
-  f->textbuff[0] = 0;
-  f->default_attrs = OWL_FMTEXT_ATTR_NONE;
-  f->default_fgcolor = OWL_COLOR_DEFAULT;
-  f->default_bgcolor = OWL_COLOR_DEFAULT;
+  f->textlen=0;
+  f->bufflen=5;
+  f->textbuff=owl_malloc(5);
+  f->fmbuff=owl_malloc(5);
+  f->fgcolorbuff=owl_malloc(5 * sizeof(short));
+  f->bgcolorbuff=owl_malloc(5 * sizeof(short));
+  f->textbuff[0]=0;
+  f->fmbuff[0]=OWL_FMTEXT_ATTR_NONE;
+  f->fgcolorbuff[0]=OWL_COLOR_DEFAULT;
+  f->bgcolorbuff[0]=OWL_COLOR_DEFAULT;
 }
 
@@ -21,9 +24,50 @@
 void owl_fmtext_clear(owl_fmtext *f)
 {
-  f->textlen = 0;
-  f->textbuff[0] = 0;
-  f->default_attrs = OWL_FMTEXT_ATTR_NONE;
-  f->default_fgcolor = OWL_COLOR_DEFAULT;
-  f->default_bgcolor = OWL_COLOR_DEFAULT;
+    f->textlen = 0;
+    f->textbuff[0] = 0;
+    f->fmbuff[0]=OWL_FMTEXT_ATTR_NONE;
+    f->fgcolorbuff[0]=OWL_COLOR_DEFAULT;
+    f->bgcolorbuff[0]=OWL_COLOR_DEFAULT;
+}
+
+/* Internal function.  Set the attribute 'attr' from index 'first' to
+ * index 'last'
+ */
+void _owl_fmtext_set_attr(owl_fmtext *f, int attr, int first, int last)
+{
+  int i;
+  for (i=first; i<=last; i++) {
+    f->fmbuff[i]=(unsigned char) attr;
+  }
+}
+
+/* Internal function.  Add the attribute 'attr' to the existing
+ * attributes from index 'first' to index 'last'
+ */
+void _owl_fmtext_add_attr(owl_fmtext *f, int attr, int first, int last)
+{
+  int i;
+  for (i=first; i<=last; i++) {
+    f->fmbuff[i]|=(unsigned char) attr;
+  }
+}
+
+/* Internal function.  Set the color to be 'color' from index 'first'
+ * to index 'last
+ */
+void _owl_fmtext_set_fgcolor(owl_fmtext *f, int color, int first, int last)
+{
+  int i;
+  for (i=first; i<=last; i++) {
+    f->fgcolorbuff[i]=(short)color;
+  }
+}
+
+void _owl_fmtext_set_bgcolor(owl_fmtext *f, int color, int first, int last)
+{
+  int i;
+  for (i=first; i<=last; i++) {
+    f->bgcolorbuff[i]=(short)color;
+  }
 }
 
@@ -31,54 +75,25 @@
 {
     if(newlen + 1 > f->bufflen) {
-      f->textbuff = owl_realloc(f->textbuff, newlen + 1);
+      f->textbuff=owl_realloc(f->textbuff, newlen+1);
+      f->fmbuff=owl_realloc(f->fmbuff, newlen+1);
+      f->fgcolorbuff=owl_realloc(f->fgcolorbuff, (newlen+1) * sizeof(short));
+      f->bgcolorbuff=owl_realloc(f->bgcolorbuff, (newlen+1) * sizeof(short));
       f->bufflen = newlen+1;
   }
 }
 
-int owl_fmtext_is_format_char(gunichar c)
-{
-  if ((c & ~OWL_FMTEXT_UC_ATTR_MASK) == OWL_FMTEXT_UC_ATTR) return 1;
-  if ((c & ~(OWL_FMTEXT_UC_ALLCOLOR_MASK)) == OWL_FMTEXT_UC_COLOR_BASE) return 1;
-  return 0;
-}
 /* append text to the end of 'f' with attribute 'attr' and color
  * 'color'
  */
-void owl_fmtext_append_attr(owl_fmtext *f, char *text, char attr, short fgcolor, short bgcolor)
-{
-  char attrbuff[6];
-  int newlen, a = 0, fg = 0, bg = 0;
-  
-  if (attr != OWL_FMTEXT_ATTR_NONE) a=1;
-  if (fgcolor != OWL_COLOR_DEFAULT) fg=1;
-  if (bgcolor != OWL_COLOR_DEFAULT) bg=1;
-
-  /* Plane-16 characters in UTF-8 are 4 bytes long. */
-  newlen = strlen(f->textbuff) + strlen(text) + (8 * (a + fg + bg));
+void owl_fmtext_append_attr(owl_fmtext *f, char *text, int attr, int fgcolor, int bgcolor)
+{
+  int newlen;
+  newlen=strlen(f->textbuff)+strlen(text);
   _owl_fmtext_realloc(f, newlen);
-
-  /* Set attributes */
-  if (a) {
-    memset(attrbuff,0,6);
-    g_unichar_to_utf8(OWL_FMTEXT_UC_ATTR | attr, attrbuff);
-    strcat(f->textbuff, attrbuff);      
-  }
-  if (fg) {
-    memset(attrbuff,0,6);
-    g_unichar_to_utf8(OWL_FMTEXT_UC_FGCOLOR | fgcolor, attrbuff);
-    strcat(f->textbuff, attrbuff);      
-  }
-  if (bg) {
-    memset(attrbuff,0,6);
-    g_unichar_to_utf8(OWL_FMTEXT_UC_BGCOLOR | bgcolor, attrbuff);
-    strcat(f->textbuff, attrbuff);      
-  }
   
   strcat(f->textbuff, text);
-
-  /* Reset attributes */
-  if (bg) strcat(f->textbuff, OWL_FMTEXT_UTF8_BGDEFAULT);
-  if (fg) strcat(f->textbuff, OWL_FMTEXT_UTF8_FGDEFAULT);
-  if (a)  strcat(f->textbuff, OWL_FMTEXT_UTF8_ATTR_NONE);
+  _owl_fmtext_set_attr(f, attr, f->textlen, newlen);
+  _owl_fmtext_set_fgcolor(f, fgcolor, f->textlen, newlen);
+  _owl_fmtext_set_bgcolor(f, bgcolor, f->textlen, newlen);
   f->textlen=newlen;
 }
@@ -114,101 +129,58 @@
 }
 
-/* Add the attribute 'attr' to the default atts for the text in 'f' */
-void owl_fmtext_addattr(owl_fmtext *f, char attr)
+/* Add the attribute 'attr' to all text in 'f' */
+void owl_fmtext_addattr(owl_fmtext *f, int attr)
 {
   /* add the attribute to all text */
-  f->default_attrs |= attr;
-}
-
-/* Set the default foreground color for this fmtext to 'color'.
- * Only affects text that is colored default.
+  int i, j;
+
+  j=f->textlen;
+  for (i=0; i<j; i++) {
+    f->fmbuff[i] |= attr;
+  }
+}
+
+/* Anywhere the color is NOT ALREDY SET, set the color to 'color'.
+ * Other colors are left unchanged
  */
 void owl_fmtext_colorize(owl_fmtext *f, int color)
 {
-  f->default_fgcolor = color;
-}
-
-/* Set the default foreground color for this fmtext to 'color'.
- * Only affects text that is colored default.
- */
+  /* everywhere the fgcolor is OWL_COLOR_DEFAULT, change it to be 'color' */
+  int i, j;
+
+  j=f->textlen;
+  for(i=0; i<j; i++) {
+    if (f->fgcolorbuff[i]==OWL_COLOR_DEFAULT) f->fgcolorbuff[i] = (short)color;
+  }
+}
+
 void owl_fmtext_colorizebg(owl_fmtext *f, int color)
 {
-  f->default_bgcolor = color;
-}
-
-/* Internal function. Parse attrbute character. */
-void _owl_fmtext_update_attributes(gunichar c, char *attr, short *fgcolor, short *bgcolor) /*noproto*/
-{
-  if ((c & OWL_FMTEXT_UC_ATTR) == OWL_FMTEXT_UC_ATTR) {
-    *attr = c & OWL_FMTEXT_UC_ATTR_MASK;
-  }
-  else if ((c & OWL_FMTEXT_UC_FGCOLOR) == OWL_FMTEXT_UC_FGCOLOR) {
-    *fgcolor = (c == OWL_FMTEXT_UC_FGDEFAULT
-		? OWL_COLOR_DEFAULT
-		: c & OWL_FMTEXT_UC_COLOR_MASK);
-  }
-  else if ((c & OWL_FMTEXT_UC_BGCOLOR) == OWL_FMTEXT_UC_BGCOLOR) {
-    *bgcolor = (c == OWL_FMTEXT_UC_BGDEFAULT
-		? OWL_COLOR_DEFAULT
-		: c & OWL_FMTEXT_UC_COLOR_MASK);
-  }
-}
-
-/* Internal function. Scan for attribute characters. */
-void _owl_fmtext_scan_attributes(owl_fmtext *f, int start, char *attr, short *fgcolor, short *bgcolor) /*noproto*/
-{
-  char *p;
-  p = strchr(f->textbuff, OWL_FMTEXT_UC_STARTBYTE_UTF8);
-  while (p && p < f->textbuff + start) {
-    _owl_fmtext_update_attributes(g_utf8_get_char(p), attr, fgcolor, bgcolor);
-    p = strchr(p+1, OWL_FMTEXT_UC_STARTBYTE_UTF8);
-  }
-}  
+  /* everywhere the bgcolor is OWL_COLOR_DEFAULT, change it to be 'color' */
+  int i, j;
+
+  j=f->textlen;
+  for(i=0; i<j; i++) {
+    if (f->bgcolorbuff[i]==OWL_COLOR_DEFAULT) f->bgcolorbuff[i] = (short)color;
+  }
+}
 
 /* Internal function.  Append text from 'in' between index 'start' and
  * 'stop' to the end of 'f'
  */
-void _owl_fmtext_append_fmtext(owl_fmtext *f, owl_fmtext *in, int start, int stop) /*noproto*/
-{
-  char attrbuff[6];
-  int newlen, a = 0, fg = 0, bg = 0;
-  char attr = 0;
-  short fgcolor = OWL_COLOR_DEFAULT;
-  short bgcolor = OWL_COLOR_DEFAULT;
-
-  _owl_fmtext_scan_attributes(in, start, &attr, &fgcolor, &bgcolor);
-  if (attr != OWL_FMTEXT_ATTR_NONE) a=1;
-  if (fgcolor != OWL_COLOR_DEFAULT) fg=1;
-  if (bgcolor != OWL_COLOR_DEFAULT) bg=1;
-
-  /* We will reset to defaults after appending the text. We may need
-     to set initial attributes. */
-  newlen=strlen(f->textbuff)+(stop-start+1) + (4 * (a + fg + bg)) + 12;
+void _owl_fmtext_append_fmtext(owl_fmtext *f, owl_fmtext *in, int start, int stop)
+{
+  int newlen, i;
+
+  newlen=strlen(f->textbuff)+(stop-start+1);
   _owl_fmtext_realloc(f, newlen);
 
-  if (a) {
-    memset(attrbuff,0,6);
-    g_unichar_to_utf8(OWL_FMTEXT_UC_ATTR | attr, attrbuff);
-    strcat(f->textbuff, attrbuff);      
-  }
-  if (fg) {
-    memset(attrbuff,0,6);
-    g_unichar_to_utf8(OWL_FMTEXT_UC_FGCOLOR | fgcolor, attrbuff);
-    strcat(f->textbuff, attrbuff);      
-  }
-  if (bg) {
-    memset(attrbuff,0,6);
-    g_unichar_to_utf8(OWL_FMTEXT_UC_BGCOLOR | bgcolor, attrbuff);
-    strcat(f->textbuff, attrbuff);      
-  }
-
   strncat(f->textbuff, in->textbuff+start, stop-start+1);
-
-  /* Reset attributes */
-  strcat(f->textbuff, OWL_FMTEXT_UTF8_BGDEFAULT);
-  strcat(f->textbuff, OWL_FMTEXT_UTF8_FGDEFAULT);
-  strcat(f->textbuff, OWL_FMTEXT_UTF8_ATTR_NONE);
-
   f->textbuff[newlen]='\0';
+  for (i=start; i<=stop; i++) {
+    f->fmbuff[f->textlen+(i-start)]=in->fmbuff[i];
+    f->fgcolorbuff[f->textlen+(i-start)]=in->fgcolorbuff[i];
+    f->bgcolorbuff[f->textlen+(i-start)]=in->bgcolorbuff[i];
+  }
   f->textlen=newlen;
 }
@@ -235,27 +207,5 @@
 char *owl_fmtext_print_plain(owl_fmtext *f)
 {
-  return owl_strip_format_chars(f->textbuff);
-}
-
-void _owl_fmtext_wattrset(WINDOW *w, int attrs) /*noproto*/
-{
-  wattrset(w, A_NORMAL);
-  if (attrs & OWL_FMTEXT_ATTR_BOLD) wattron(w, A_BOLD);
-  if (attrs & OWL_FMTEXT_ATTR_REVERSE) wattron(w, A_REVERSE);
-  if (attrs & OWL_FMTEXT_ATTR_UNDERLINE) wattron(w, A_UNDERLINE);
-}
-
-void _owl_fmtext_update_colorpair(short fg, short bg, short *pair) /*noproto*/
-{
-  if (owl_global_get_hascolors(&g)) {
-    *pair = owl_fmtext_get_colorpair(fg, bg);
-  }
-}
-
-void _owl_fmtext_wcolor_set(WINDOW *w, short pair) /*noproto*/
-{
-  if (owl_global_get_hascolors(&g)) {
-      wcolor_set(w,pair,NULL);
-  }
+  return(owl_strdup(f->textbuff));
 }
 
@@ -263,13 +213,9 @@
  * must already be initiatlized with curses
  */
-void _owl_fmtext_curs_waddstr(owl_fmtext *f, WINDOW *w, int do_search) /*noproto*/
-{
-  /* char *tmpbuff; */
-  /* int position, trans1, trans2, trans3, len, lastsame; */
-  char *s, *p;
-  char attr;
-  short fg, bg, pair;
-  int search_results, search_len;
-  
+void owl_fmtext_curs_waddstr(owl_fmtext *f, WINDOW *w)
+{
+  char *tmpbuff;
+  int position, trans1, trans2, trans3, len, lastsame;
+
   if (w==NULL) {
     owl_function_debugmsg("Hit a null window in owl_fmtext_curs_waddstr.");
@@ -277,96 +223,53 @@
   }
 
-  search_results = (do_search
-		    ? owl_fmtext_search(f, owl_global_get_search_string(&g))
-		    : 0);
-  search_len = (search_results
-		? strlen(owl_global_get_search_string(&g))
-		: 0);
-  s = f->textbuff;
-  /* Set default attributes. */
-  attr = f->default_attrs;
-  fg = f->default_fgcolor;
-  bg = f->default_bgcolor;
-  _owl_fmtext_wattrset(w, attr);
-  _owl_fmtext_update_colorpair(fg, bg, &pair);
-  _owl_fmtext_wcolor_set(w, pair);
-
-  /* Find next possible format character. */
-  p = strchr(s, OWL_FMTEXT_UC_STARTBYTE_UTF8);
-  while(p) {
-    if (owl_fmtext_is_format_char(g_utf8_get_char(p))) {
-      /* Deal with all text from last insert to here. */
-      char tmp;
-   
-      tmp = p[0];
-      p[0] = '\0';
-      if (search_results) {
-	/* Search is active, so highlight search results. */
-	char tmp2, *ss;
-	ss = stristr(s, owl_global_get_search_string(&g));
-	while (ss) {
-	  /* Found search string, highlight it. */
-
-	  tmp2 = ss[0];
-	  ss[0] = '\0';
-	  waddstr(w, s);
-	  ss[0] = tmp2;
-
-	  _owl_fmtext_wattrset(w, attr ^ OWL_FMTEXT_ATTR_REVERSE);
-	  _owl_fmtext_wcolor_set(w, pair);
-	  
-	  tmp2 = ss[search_len];
-	  ss[search_len] = '\0';
-	  waddstr(w, ss);
-	  ss[search_len] = tmp2;
-
-	  _owl_fmtext_wattrset(w, attr);
-	  _owl_fmtext_wcolor_set(w, pair);
-
-	  s = ss + search_len;
-	  ss = stristr(s, owl_global_get_search_string(&g));
-	}
-      }
-      /* Deal with remaining part of string. */
-      waddstr(w, s);
-      p[0] = tmp;
-
-      /* Deal with new attributes. Initialize to defaults, then
-	 process all consecutive formatting characters. */
-      attr = f->default_attrs;
-      fg = f->default_fgcolor;
-      bg = f->default_bgcolor;
-      while (p && owl_fmtext_is_format_char(g_utf8_get_char(p))) {
-	_owl_fmtext_update_attributes(g_utf8_get_char(p), &attr, &fg, &bg);
-	p = g_utf8_next_char(p);
-      }
-      _owl_fmtext_wattrset(w, attr | f->default_attrs);
-      if (fg == OWL_COLOR_DEFAULT) fg = f->default_fgcolor;
-      if (bg == OWL_COLOR_DEFAULT) bg = f->default_bgcolor;
-      _owl_fmtext_update_colorpair(fg, bg, &pair);
-      _owl_fmtext_wcolor_set(w, pair);
-
-      /* Advance to next non-formatting character. */
-      s = p;
-      p = strchr(s, OWL_FMTEXT_UC_STARTBYTE_UTF8);
-    }
-    else {
-      p = strchr(p+1, OWL_FMTEXT_UC_STARTBYTE_UTF8);
-    }
-  }
-  if (s) {
-    waddstr(w, s);
-  }
-}
-
-void owl_fmtext_curs_waddstr(owl_fmtext *f, WINDOW *w)
-{
-  _owl_fmtext_curs_waddstr(f, w, owl_global_is_search_active(&g));
-}
-
-void owl_fmtext_curs_waddstr_without_search(owl_fmtext *f, WINDOW *w)
-{
-  _owl_fmtext_curs_waddstr(f, w, 0);
-}
+  tmpbuff=owl_malloc(f->textlen+10);
+
+  position=0;
+  len=f->textlen;
+  while (position<=len) {
+    /* find the last char with the current format and color */
+    trans1=owl_util_find_trans(f->fmbuff+position, len-position);
+    trans2=owl_util_find_trans_short(f->fgcolorbuff+position, len-position);
+    trans3=owl_util_find_trans_short(f->bgcolorbuff+position, len-position);
+
+    lastsame = (trans1 < trans2) ? trans1 : trans2;
+    lastsame = (lastsame < trans3) ? lastsame : trans3;
+    lastsame += position;
+
+    /* set the format */
+    wattrset(w, A_NORMAL);
+    if (f->fmbuff[position] & OWL_FMTEXT_ATTR_BOLD) {
+      wattron(w, A_BOLD);
+    }
+    if (f->fmbuff[position] & OWL_FMTEXT_ATTR_REVERSE) {
+      wattron(w, A_REVERSE);
+    }
+    if (f->fmbuff[position] & OWL_FMTEXT_ATTR_UNDERLINE) {
+      wattron(w, A_UNDERLINE);
+    }
+
+    /* set the color */
+    /* warning, this is sort of a hack */
+    if (owl_global_get_hascolors(&g)) {
+      short fg, bg, pair;
+      fg = f->fgcolorbuff[position];
+      bg = f->bgcolorbuff[position];
+
+      pair = owl_fmtext_get_colorpair(fg, bg);
+      if (pair != -1) {
+        wcolor_set(w,pair,NULL);
+      }
+    }
+
+    /* add the text */
+    strncpy(tmpbuff, f->textbuff + position, lastsame-position+1);
+    tmpbuff[lastsame-position+1]='\0';
+    waddstr(w, tmpbuff);
+
+    position=lastsame+1;
+  }
+  owl_free(tmpbuff);
+}
+
 
 /* start with line 'aline' (where the first line is 0) and print
@@ -379,30 +282,26 @@
   
   /* find the starting line */
-  ptr1 = in->textbuff;
-  for (i = 0; i < aline; i++) {
-    ptr1 = strchr(ptr1, '\n');
-    if (!ptr1) return(-1);
-    ptr1++;
-  }
-  
+  ptr1=in->textbuff;
+  if (aline!=0) {
+    for (i=0; i<aline; i++) {
+      ptr1=strchr(ptr1, '\n');
+      if (!ptr1) return(-1);
+      ptr1++;
+    }
+  }
   /* ptr1 now holds the starting point */
 
-  /* copy the default attributes */
-  out->default_attrs = in->default_attrs;
-  out->default_fgcolor = in->default_fgcolor;
-  out->default_bgcolor = in->default_bgcolor;
-    
   /* copy in the next 'lines' lines */
-  if (lines < 1) return(-1);
-
-  for (i = 0; i < lines; i++) {
-    offset = ptr1 - in->textbuff;
-    ptr2 = strchr(ptr1, '\n');
+  if (lines<1) return(-1);
+
+  for (i=0; i<lines; i++) {
+    offset=ptr1-in->textbuff;
+    ptr2=strchr(ptr1, '\n');
     if (!ptr2) {
-      _owl_fmtext_append_fmtext(out, in, offset, (in->textlen) - 1);
+      _owl_fmtext_append_fmtext(out, in, offset, (in->textlen)-1);
       return(-1);
     }
-    _owl_fmtext_append_fmtext(out, in, offset, (ptr2 - ptr1) + offset);
-    ptr1 = ptr2 + 1;
+    _owl_fmtext_append_fmtext(out, in, offset, (ptr2-ptr1)+offset);
+    ptr1=ptr2+1;
   }
   return(0);
@@ -412,80 +311,47 @@
  * ends at 'bcol' or sooner.  The first column is number 0.  The new
  * message is placed in 'out'.  The message is * expected to end in a
- * new line for now. NOTE: This needs to be modified to deal with
- * backing up if we find a SPACING COMBINING MARK at the end of a
- * line. If that happens, we should back up to the last non-mark
- * character and stop there.
+ * new line for now
  */
 void owl_fmtext_truncate_cols(owl_fmtext *in, int acol, int bcol, owl_fmtext *out)
 {
-  char *ptr_s, *ptr_e, *ptr_c, *last;
-  int col, st, padding, chwidth;
-
-  /* copy the default attributes */
-  out->default_attrs = in->default_attrs;
-  out->default_fgcolor = in->default_fgcolor;
-  out->default_bgcolor = in->default_bgcolor;
+  char *ptr1, *ptr2, *last;
+  int len, offset;
 
   last=in->textbuff+in->textlen-1;
-  ptr_s=in->textbuff;
-  while (ptr_s <= last) {
-    ptr_e=strchr(ptr_s, '\n');
-    if (!ptr_e) {
+  ptr1=in->textbuff;
+  while (ptr1<=last) {
+    ptr2=strchr(ptr1, '\n');
+    if (!ptr2) {
       /* but this shouldn't happen if we end in a \n */
       break;
     }
     
-    if (ptr_e == ptr_s) {
+    if (ptr2==ptr1) {
       owl_fmtext_append_normal(out, "\n");
-      ++ptr_s;
+      ptr1++;
       continue;
     }
 
-    col = 0;
-    st = 0;
-    padding = 0;
-    chwidth = 0;
-    ptr_c = ptr_s;
-    while(ptr_c < ptr_e) {
-      gunichar c = g_utf8_get_char(ptr_c);
-      if (!owl_fmtext_is_format_char(c)) {
-	chwidth = mk_wcwidth(c);
-	if (col + chwidth > bcol) break;
-	
-	if (col >= acol) {
-	  if (st == 0) {
-	    ptr_s = ptr_c;
-	    padding = col - acol;
-	    ++st;
-	  }
-	}
-	col += chwidth;
-	chwidth = 0;
-      }
-      ptr_c = g_utf8_next_char(ptr_c);
-    }
-    if (st) {
-      /* lead padding */
-      owl_fmtext_append_spaces(out, padding);
-      if (ptr_c == ptr_e) {
-	/* We made it to the newline. */
-	_owl_fmtext_append_fmtext(out, in, ptr_s - in->textbuff, ptr_c - in->textbuff);
-      }
-      else {
-	if (chwidth > 1) {
-	  /* Last char is wide, truncate. */
-	  _owl_fmtext_append_fmtext(out, in, ptr_s - in->textbuff, ptr_c - in->textbuff - 1);
-	  owl_fmtext_append_normal(out, "\n");
-	}
-	else {
-	  /* Last char fits perfectly, leave alone.*/
-	  _owl_fmtext_append_fmtext(out, in, ptr_s - in->textbuff, ptr_c - in->textbuff);
-	}
-      }
-    }
-    else {
+    /* we need to check that we won't run over here */
+    len=bcol-acol;
+    if (len > (ptr2-(ptr1+acol))) {
+      /* the whole line fits with room to spare, don't take a full 'len' */
+      len=ptr2-(ptr1+acol);
+    }
+    if (len>last-ptr1) {
+      /* the whole rest of the text fits with room to spare, adjust for it */
+      len-=(last-ptr1);
+    }
+    if (len<=0) {
+      /* saftey check */
       owl_fmtext_append_normal(out, "\n");
-    }
-    ptr_s = g_utf8_next_char(ptr_e);
+      ptr1=ptr2+1;
+      continue;
+    }
+
+    offset=ptr1-in->textbuff;
+    _owl_fmtext_append_fmtext(out, in, offset+acol, offset+acol+len);
+
+    ptr1=ptr2+1;
   }
 }
@@ -515,11 +381,8 @@
 
 /* set the charater at 'index' to be 'char'.  If index is out of
- * bounds don't do anything. If c or char at index is not ASCII, don't
- * do anything because it's not UTF-8 safe. */
-void owl_fmtext_set_char(owl_fmtext *f, int index, char ch)
+ * bounds don't do anything */
+void owl_fmtext_set_char(owl_fmtext *f, int index, int ch)
 {
   if ((index < 0) || (index > f->textlen-1)) return;
-  /* NOT ASCII*/
-  if (f->textbuff[index] & 0x80 || ch & 0x80) return; 
   f->textbuff[index]=ch;
 }
@@ -537,8 +400,37 @@
   dst->textlen=src->textlen;
   dst->textbuff=owl_malloc(mallocsize);
+  dst->fmbuff=owl_malloc(mallocsize);
+  dst->fgcolorbuff=owl_malloc(mallocsize * sizeof(short));
+  dst->bgcolorbuff=owl_malloc(mallocsize * sizeof(short));
   memcpy(dst->textbuff, src->textbuff, src->textlen+1);
-  dst->default_attrs = src->default_attrs;
-  dst->default_fgcolor = src->default_fgcolor;
-  dst->default_bgcolor = src->default_bgcolor;
+  memcpy(dst->fmbuff, src->fmbuff, src->textlen);
+  memcpy(dst->fgcolorbuff, src->fgcolorbuff, src->textlen * sizeof(short));
+  memcpy(dst->bgcolorbuff, src->bgcolorbuff, src->textlen * sizeof(short));
+}
+
+/* highlight all instances of "string".  Return the number of
+ * instances found.  This is a case insensitive search.
+ */
+int owl_fmtext_search_and_highlight(owl_fmtext *f, char *string)
+{
+
+  int found, len;
+  char *ptr1, *ptr2;
+
+  len=strlen(string);
+  found=0;
+  ptr1=f->textbuff;
+  while (ptr1-f->textbuff <= f->textlen) {
+    ptr2=stristr(ptr1, string);
+    if (!ptr2) return(found);
+
+    found++;
+    _owl_fmtext_add_attr(f, OWL_FMTEXT_ATTR_REVERSE,
+                         ptr2 - f->textbuff,
+                         ptr2 - f->textbuff + len - 1);
+
+    ptr1=ptr2+len;
+  }
+  return(found);
 }
 
@@ -548,4 +440,5 @@
 int owl_fmtext_search(owl_fmtext *f, char *string)
 {
+
   if (stristr(f->textbuff, string)) return(1);
   return(0);
@@ -788,4 +681,7 @@
 {
   if (f->textbuff) owl_free(f->textbuff);
+  if (f->fmbuff) owl_free(f->fmbuff);
+  if (f->fgcolorbuff) owl_free(f->fgcolorbuff);
+  if (f->bgcolorbuff) owl_free(f->bgcolorbuff);
 }
 
Index: functions.c
===================================================================
--- functions.c	(revision f9eea4c2b610d8a43d97d158b483c245238165c7)
+++ functions.c	(revision 36172860060e404e761fc6fd5503c09ef88bd83d)
@@ -1606,5 +1606,5 @@
 	  sprintf(buff, "  Field %i   : ", i+1);
 	  
-	  ptr=owl_zephyr_get_field_as_utf8(n, i+1);
+	  ptr=owl_zephyr_get_field(n, i+1);
 	  len=strlen(ptr);
 	  if (len<30) {
@@ -2187,4 +2187,5 @@
 void owl_function_start_command(char *line)
 {
+  int i, j;
   owl_editwin *tw;
 
@@ -2197,5 +2198,8 @@
   owl_global_set_needrefresh(&g);
 
-  owl_editwin_insert_string(tw, line);
+  j=strlen(line);
+  for (i=0; i<j; i++) {
+    owl_editwin_process_char(tw, line[i]);
+  }
   owl_editwin_redisplay(tw, 0);
 
@@ -2595,11 +2599,5 @@
   }
   /* downcase it */
-  {
-    char *temp = g_utf8_strdown(filtname, -1);
-    if (temp) {
-      owl_free(filtname);
-      filtname = temp;
-    }
-  }
+  downstr(filtname);
   /* turn spaces, single quotes, and double quotes into dots */
   owl_text_tr(filtname, ' ', '.');
@@ -3026,5 +3024,5 @@
   char *quoted;
 
-  buff=owl_malloc(strlen(class)+strlen(inst)+strlen(recip)+100);
+  buff=malloc(strlen(class)+strlen(inst)+strlen(recip)+100);
   strcpy(buff, "class");
   if (!strcmp(class, "*")) {
@@ -3330,5 +3328,5 @@
           if (ret==0) {
             for (x=0; x<numlocs; x++) {
-              line=owl_malloc(strlen(location[x].host)+strlen(location[x].time)+strlen(location[x].tty)+100);
+              line=malloc(strlen(location[x].host)+strlen(location[x].time)+strlen(location[x].tty)+100);
               tmp=short_zuser(user);
               sprintf(line, "  %-10.10s %-24.24s %-12.12s  %20.20s\n",
@@ -3373,5 +3371,4 @@
   owl_view *v;
   FILE *file;
-  char *plaintext;
 
   v=owl_global_get_current_view(&g);
@@ -3396,9 +3393,5 @@
   for (i=0; i<j; i++) {
     m=owl_view_get_element(v, i);
-    plaintext = owl_strip_format_chars(owl_message_get_text(m));
-    if (plaintext) {
-      fputs(plaintext, file);
-      owl_free(plaintext);
-    }
+    fputs(owl_message_get_text(m), file);
   }
   fclose(file);
@@ -3441,5 +3434,5 @@
 	  _exit(127);
 	}
-	parsed=owl_realloc(parsed, sizeof(*parsed) * (myargc+1));
+	parsed=realloc(parsed, sizeof(*parsed) * (myargc+1));
 	parsed[myargc] = NULL;
 	
Index: global.c
===================================================================
--- global.c	(revision eebef194307e93a0e2956946794840c21dd8c4ba)
+++ global.c	(revision eebef194307e93a0e2956946794840c21dd8c4ba)
@@ -549,5 +549,5 @@
     len+=strlen(argv[i])+5;
   }
-  g->startupargs=owl_malloc(len+5);
+  g->startupargs=malloc(len+5);
 
   strcpy(g->startupargs, "");
Index: keymap.c
===================================================================
--- keymap.c	(revision 428834dd2aedac4b5fc2874635c22897ffa16c22)
+++ keymap.c	(revision cf83b7a15ef998b48ca0aa69dae69a963b365dc1)
@@ -5,5 +5,5 @@
 
 /* returns 0 on success */
-int owl_keymap_init(owl_keymap *km, char *name, char *desc, void (*default_fn)(owl_input), void (*prealways_fn)(owl_input), void (*postalways_fn)(owl_input))
+int owl_keymap_init(owl_keymap *km, char *name, char *desc, void (*default_fn)(int), void (*prealways_fn)(int), void (*postalways_fn)(int))
 {
   if (!name || !desc) return(-1);
@@ -151,5 +151,5 @@
 }
 
-owl_keymap *owl_keyhandler_create_and_add_keymap(owl_keyhandler *kh, char *name, char *desc, void (*default_fn)(owl_input), void (*prealways_fn)(owl_input), void (*postalways_fn)(owl_input))
+owl_keymap *owl_keyhandler_create_and_add_keymap(owl_keyhandler *kh, char *name, char *desc, void (*default_fn)(int), void (*prealways_fn)(int), void (*postalways_fn)(int))
 {
   owl_keymap *km;
@@ -202,5 +202,5 @@
 /* processes a keypress.  returns 0 if the keypress was handled,
  * 1 if not handled, -1 on error, and -2 if j==ERR. */
-int owl_keyhandler_process(owl_keyhandler *kh, owl_input j)
+int owl_keyhandler_process(owl_keyhandler *kh, int j)
 {
   owl_keymap     *km;
@@ -214,5 +214,5 @@
 
   /* temporarily disallow C-`/C-SPACE until we fix associated bugs */
-  if (j.ch == ERR || j.ch == 0) {
+  if (j==ERR || j==0) {
 	return(-1);
   }
@@ -224,14 +224,14 @@
 
   /* deal with ESC prefixing */
-  if (!kh->in_esc && j.ch == 27) {
+  if (!kh->in_esc && j==27) {
     kh->in_esc = 1;
     return(0);
   }
   if (kh->in_esc) {
-    j.ch = OWL_META(j.ch);
+    j = OWL_META(j);
     kh->in_esc = 0;
   }
   
-  kh->kpstack[++(kh->kpstackpos)] = j.ch;
+  kh->kpstack[++(kh->kpstackpos)] = j;
   if (kh->kpstackpos >= OWL_KEYMAP_MAXSTACK) {
     owl_keyhandler_reset(kh);
@@ -260,5 +260,5 @@
       } else if (match == 2) {	/* exact match */
 	/* owl_function_debugmsg("processkey: found exact match in %s", km->name); */
-	owl_keybinding_execute(kb, j.ch);
+	owl_keybinding_execute(kb, j);
 	owl_keyhandler_reset(kh);
 	if (km->postalways_fn) {
Index: keys.c
===================================================================
--- keys.c	(revision fac5463dbde789ec17cf1e7b828366dd7911806f)
+++ keys.c	(revision 8938188651289a80e4f3129f765c9ac991d254a3)
@@ -294,25 +294,25 @@
 /****************************************************************/
 
-void owl_keys_recwin_prealways(owl_input j) {
+void owl_keys_recwin_prealways(int j) {
   /* Clear the message line on subsequent key presses */
   owl_function_makemsg("");
 }
 
-void owl_keys_editwin_default(owl_input j) {
+void owl_keys_editwin_default(int j) {
   owl_editwin *e;
   if (NULL != (e=owl_global_get_typwin(&g))) {
-       owl_editwin_process_char(e, j);
+    owl_editwin_process_char(e, j);
   }
 }
 
-void owl_keys_editwin_postalways(owl_input j) {
+void owl_keys_editwin_postalways(int j) {
   owl_editwin *e;
   if (NULL != (e=owl_global_get_typwin(&g))) {
     owl_editwin_post_process_char(e, j);
-  }
+  }  
   owl_global_set_needrefresh(&g);
 }
 
-void owl_keys_popless_postalways(owl_input j) {
+void owl_keys_popless_postalways(int j) {
   owl_viewwin *v = owl_global_get_viewwin(&g);
   owl_popwin *pw = owl_global_get_popwin(&g);
@@ -323,7 +323,7 @@
 }
 
-void owl_keys_default_invalid(owl_input j) {
-  if (j.ch==ERR) return;
-  if (j.ch==410) return;
+void owl_keys_default_invalid(int j) {
+  if (j==ERR) return;
+  if (j==410) return;
   owl_keyhandler_invalidkey(owl_global_get_keyhandler(&g));
 }
Index: logging.c
===================================================================
--- logging.c	(revision 28ee32b3f0b785ed3f83357207feda49cfdb61b4)
+++ logging.c	(revision d0961fe0bc68cec33bc23afbae4928bbd861d718)
@@ -155,9 +155,7 @@
     to = owl_sprintf("jabber:%s", owl_message_get_recipient(m));
   } else if (owl_message_is_type_aim(m)) {
-    char *temp2;
     temp = owl_aim_normalize_screenname(owl_message_get_recipient(m));
-    temp2 = g_utf8_strdown(temp,-1);
-    to = owl_sprintf("aim:%s", temp2);
-    owl_free(temp2);
+    downstr(temp);
+    to = owl_sprintf("aim:%s", temp);
     owl_free(temp);
   } else {
@@ -269,10 +267,9 @@
   } else if (owl_message_is_type_aim(m)) {
     /* we do not yet handle chat rooms */
-    char *normalto, *temp;
-    temp = owl_aim_normalize_screenname(owl_message_get_sender(m));
-    normalto = g_utf8_strdown(temp, -1);
+    char *normalto;
+    normalto=owl_aim_normalize_screenname(owl_message_get_sender(m));
+    downstr(normalto);
     from=frombuff=owl_sprintf("aim:%s", normalto);
     owl_free(normalto);
-    owl_free(temp);
   } else if (owl_message_is_type_loopback(m)) {
     from=frombuff=owl_strdup("loopback");
@@ -293,5 +290,5 @@
 
   ch=frombuff[0];
-  if (!g_ascii_isalnum(ch)) from="weird";
+  if (!isalnum(ch)) from="weird";
 
   for (i=0; i<len; i++) {
@@ -302,11 +299,5 @@
 
   if (!personal) {
-    if (strcmp(from, "weird")) {
-      char* temp = g_utf8_strdown(frombuff, -1);
-      if (temp) {
-	owl_free(frombuff);
-	from = frombuff = temp;
-      }
-    }
+    if (strcmp(from, "weird")) downstr(from);
   }
 
Index: message.c
===================================================================
--- message.c	(revision 635881c74d5db520489dd93640fdefa1f71d4988)
+++ message.c	(revision 635881c74d5db520489dd93640fdefa1f71d4988)
@@ -79,5 +79,5 @@
     owl_list_append_element(&(m->attributes), pair);
   }
-  owl_pair_set_value(pair, owl_validate_or_convert(attrvalue));
+  owl_pair_set_value(pair, owl_strdup(attrvalue));
 }
 
@@ -493,5 +493,5 @@
 {
   if(m->zwriteline) owl_free(m->zwriteline);
-  m->zwriteline=owl_strdup(line);
+  m->zwriteline=strdup(line);
 }
 
@@ -535,9 +535,17 @@
   owl_fmtext_init_null(&b);
   
-  owl_fmtext_truncate_lines(&(m->fmtext->fmtext), aline, bline-aline, &a);
+  owl_fmtext_truncate_lines(&(m->fmtext->fmtext), aline, bline-aline+1, &a);
   owl_fmtext_truncate_cols(&a, acol, bcol, &b);
-  owl_fmtext_colorize(&b, fgcolor);
-  owl_fmtext_colorizebg(&b, bgcolor);
-
+  if (fgcolor!=OWL_COLOR_DEFAULT) {
+    owl_fmtext_colorize(&b, fgcolor);
+  }
+  if (bgcolor!=OWL_COLOR_DEFAULT) {
+    owl_fmtext_colorizebg(&b, bgcolor);
+  }
+
+  if (owl_global_is_search_active(&g)) {
+    owl_fmtext_search_and_highlight(&b, owl_global_get_search_string(&g));
+  }
+      
   owl_fmtext_curs_waddstr(&b, win);
 
@@ -882,5 +890,5 @@
   }
 
-  m->zwriteline=owl_strdup("");
+  m->zwriteline=strdup("");
 
   /* save the hostname */
@@ -964,5 +972,5 @@
   }
 
-  m->zwriteline=owl_strdup("");
+  m->zwriteline=strdup("");
 
   owl_message_set_body(m, "<uninitialized>");
